# -------------------------------------------------------------------------------------
# MKDoc::Handler::Authenticate
# -------------------------------------------------------------------------------------
# Author: Jean-Michel Hiver (jhiver@mkdoc.com).
# Copyright: (c) MKDoc Holdings Ltd, 2003
# Description: Authenticates against MKDoc's 'Editor' table
# -------------------------------------------------------------------------------------
package MKDoc::Handler::Authenticate;
use strict;
use warnings;
use Carp;

use flo::Standard;
use Apache::Constants qw/:common/;
use strict;
use warnings;


sub handler
{
    my $r = shift;
    
    # checks that the user has sent a login / password pair
    my ($res, $sent_pw) = $r->get_basic_auth_pw;
    return $res if $res != OK;
    
    my $login = $r->connection->user;
    unless ($login and $sent_pw)
    {
        $r->note_basic_auth_failure;
        $r->log_reason ("Both username and passwords must be provided, ", $r->filename);
        return AUTH_REQUIRED;
    }
    
    # fetches the user's password
    my $editor_t = flo::Standard::table ('Editor');
    my $editor   = $editor_t->get (Login => $login) || return AUTH_REQUIRED;
    
    # compares the real password with the provided password
    return ($editor->password() eq $sent_pw) ? OK : AUTH_REQUIRED;
}


1;


__END__
