# -------------------------------------------------------------------------------------
# MKDoc::XML::XHTML::Filter
# -------------------------------------------------------------------------------------
#
#       Author : Jean-Michel Hiver (jhiver@mkdoc.com).
#    Copyright : (c) MKDoc Holdings Ltd, 2001
# 
#      Unauthorized modification, use, reuse, distribution or redistribution
#      of this module is stricly forbidden
#
#    Description:
#
#      A class to handle most annoying unicode stuff
#
# -------------------------------------------------------------------------------------
package MKDoc::XML::XHTML::Filter;
use MKDoc::XML::Tree;
use XML::Parser;
use Exporter;
use strict;
use 5.008_000;
use utf8;


our @ISA = qw /MKDoc::XML::Tree/;
our $OK_Tags = {
    html => 1,
    p => 1,
    strong => 2,
};


sub filter
{
    my $self = shift;
    return if ($self->{is_text});
    
    my $self_name = $self->name;
    if (not (defined $OK_Tags->{$self_name} and $OK_Tags->{$self_name}))
    {
	$self->replace_with ($self->children);
    }
    
    foreach my $child ($self->children)
    {
	$child->filter;
    }
}


1;
