# -----------------------------------------------------------------------------
# MKDoc::Test::SiteObject
# -----------------------------------------------------------------------------
#       Author : Steve Purkis <spurkis@mkdoc.com>
#    Copyright : Copyright (c) 2002 MKDoc Holdings Ltd.  All rights reserved.
#      Version : $Id: SiteObject.pm,v 1.1.2.1 2002/12/10 18:49:03 spurkis Exp $
#   Description: Inheritance test for MKDoc::Site::Object
# -----------------------------------------------------------------------------

package MKDoc::Test::SiteObject;

use strict;
use warnings;

use base qw/ MKDoc::Site::Object /;

our $DEBUG        = 'test_debug';
our $VERSION      = 'test_version';
our @DEBUG_OUTPUT = ();

# new( @args ) should call _initialize(@args):
sub _initialize
{
    my $self      = shift;
    $self->{init} = shift;
    return $self;
}

# test _set_instance_vars:
sub set_good
{
    my $self      = shift;
    $self->{good} = shift;
    return $self;
}

sub set_bad { return undef; }

# test not_implemented:
sub unimpl
{
    my $self      = shift;
    return $self->not_implemented(@_);
}


package MKDoc::Site::Object;

##
# $SIG{__WARN__}
# --------------
# all debug() calls should call warn, so
# redirect output to @MKDoc::Test::SiteObject::DEBUG_OUTPUT:
##
$MKDoc::Site::Object::SIG{__WARN__} = sub
{
    push @MKDoc::Test::SiteObject::DEBUG_OUTPUT, @_;
};



1;

__END__
