#!/usr/bin/perl
use strict;
use warnings;
use MKDoc::Handler::Initialize;
use MKDoc::Site::Check::RelationShips;
$ENV{MKDOC_DIR} || die 'MKDOC_DIR is not defined!';


main();
sub main
{
    defined $ENV{SITE_DIR} and return do {
        MKDoc::Handler::Initialize::handler();
        MKDoc::Site::Check::RelationShips->check();
    };
    
    foreach my $mkdoc_site (site_list())
    {
        print "CHECKING REDIRECTS: $mkdoc_site\n";
        $ENV{SITE_DIR} = $mkdoc_site;
        main();
    }
}

##
# site_list;
# ----------
# Returns every registered domain starting with 'www'.
##
sub site_list
{
    my $file = $ENV{MKDOC_DIR} . '/conf/sites.conf';
    open FP, "<$file" || die "Cannot read-open $file!";
    my $data = join '', <FP>;
    close FP;
    
    my $VAR1;
    eval $data || die $@;

    my %set = ();
    for (values %{$VAR1}) { $set{$_} = 1 }
    return sort keys %set;
}


1;


